﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;
	import flash.display.Stage;
	
	public class Fourmizer extends Sprite
	{
		private var quantity:Number = 20;
		private var dotNum:Number = 0;
		private var dots:Array = [];
		private var vitesseMax:Number = 5;
		private var colors:Array = [Math.random()*0xFFFFFF,Math.random()*0xFFFFFF];
		
		//private var isDrag:Boolean=false;
		
		public function Fourmizer()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mousedown);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, changer);
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		
		private function mousedown(e:MouseEvent):void
		{
		
			for(var i:Number = 0;i<quantity;i++){
				//addDot(Math.random()*stage.stageWidth,Math.random()*stage.stageHeight);
				addDot(mouseX,mouseY);
			}
			
		}
		
		private function addDot(x:Number,y:Number):void
		{
			dots[dotNum] = new Object();
			dots[dotNum].x = x;
			dots[dotNum].y = y;
			dots[dotNum].angle = Math.random()*2*Math.PI;
			dots[dotNum].v = Math.random()*vitesseMax;
			dots[dotNum].s = new Sprite();
			dots[dotNum].s.graphics.beginFill(colors,.9);
			dots[dotNum].s.graphics.drawCircle(0,0,Math.random()*30);
			dots[dotNum].s.graphics.endFill();
			
			var glow:GlowFilter = new GlowFilter();
			glow.color = 0xFFFFFF;
			glow.alpha = .9;
			glow.blurX = 50;
			glow.blurY = 50;
			glow.quality = BitmapFilterQuality.MEDIUM;
			this.filters = [glow];
			//dots[dotNum].addEventListener(MouseEvent.MOUSE_DOWN,clikk);
			//dots[dotNum].addEventListener(MouseEvent.MOUSE_UP, clikkUp);
			addChild(dots[dotNum].s);
			dotNum++;
		}
		
		/*private function clikk (e:MouseEvent)
		{ 
			isDrag=true;
			e.currentTarget.startDrag(true); // prend l'element en question
		  }
		  
		  private function clikkUp (e:MouseEvent)
		{
			isDrag=false;
			e.currentTarget.stopDrag();
			}
			*/
		
		private function enterHandler(e:Event):void
		{
			movedot();
			
		}
		
		private function changer(e:MouseEvent):void{
			
			colors = [Math.random()*0xFFFFFF,Math.random()*0xFFFFFF]
			
		}
		
		private function movedot():void
		{
			
			var i:Number,t:Number;
			var a:Number,s:Number,xs:Number,ys:Number,cx:Number,cy:Number,vx:Number,vy:Number;
			
			for(i = 0;i<dotNum;i++){
				xs = dots[i].x;
				ys = dots[i].y;
				a = dots[i].angle;
				s = dots[i].v;
				vx = Math.cos(a)*s*Math.random()*2;
				vy = Math.sin(a)*s*Math.random()*2;
				xs+=vx;
				ys+=vy;
				if(xs<3 || xs>=stage.stageWidth-3 || ys<3 ||ys>=stage.stageHeight-3){
					if(xs<3){
						xs = 3
						vx*=-1;
					}
					if(xs>stage.stageWidth-4){
						xs = stage.stageWidth-4;
						vx*=-1;
					}
					if(ys<3){
						ys = 3;
						vy*=-1;
					}
					if(ys>stage.stageHeight-4){
						ys = stage.stageHeight-4;
						vy*=-1;
					}
					dots[i].angle = Math.atan2(vy,vx);
				}
				
				
				
				//position
				
				dots[i].s.x = dots[i].x = xs;
				dots[i].s.y = dots[i].y = ys;
				if(Math.random()<.1){
					//i--;
					dots[i].angle--;
				}
				if(Math.random()<.1){
					dots[i].v+=Math.random()-.5;
					dots[i].v = Math.max(0,Math.min(vitesseMax,Math.abs(dots[i].v)));
				}
			}
			
		}
		
		
	}
}